
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Attribute鲜为人知的两个特性记录 / iVAN</title>

    <meta name="description" content="Attribute鲜为人知的两个特性记录     Attribute作为一种标记在我们的.net中随处可见,比如DatContract,DatMember,Serializable等等,各种用途的标记.是的我们的代码更加简洁,对于Attribute用好了,可以很好的简化我们的开发,比如PostSharp的AOP实现就是一种基于Attribute的标记编译时注入.在随笔中有关于IOC,AOP利用Attribute标记简化开发的实例.    在使用Attribute时候发现了些鲜为人知的特性: 1:利用GetCustomAttributes">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Attribute鲜为人知的两个特性记录</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>    Attribute作为一种标记在我们的.net中随处可见，比如DatContract，DatMember，Serializable等等，各种用途的标记。是的我们的代码更加简洁，对于Attribute用好了，可以很好的简化我们的开发，比如<a href="http://www.cnblogs.com/whitewolf/archive/2012/02/12/2348521.html" rel="external nofollow noreferrer">PostSharp的AOP</a>实现就是一种基于Attribute的标记编译时注入。在随笔中有<a href="http://www.cnblogs.com/whitewolf/archive/2012/02/12/2348521.html" rel="external nofollow noreferrer">关于IOC，AOP利用Attribute标记简化开发</a>的实例。</p>
<p>   在使用Attribute时候发现了些鲜为人知的特性：</p>
<blockquote><p>1：利用GetCustomAttributes传入的Attribute返回得到包括派生类。</p>
<p>2：GetCustomAttributes每次返回的对象都是经过发射出来的没有缓存。</p></blockquote>
<p>   1：GetCustomAttributes传入的Attribute返回得到包括派生类：</p>
<p>       这里将采用一个测试类来验证：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg"></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>[AttributeUsage(AttributeTargets.Class)] <br />
  public class TestImplementsAttribute : Attribute <br />
  { <br />
      public string Name <br />
      { get; set; } <br />
  }</p>
<p> </p>
<p>private static void TestMutilpeImplements() <br />
{ <br />
    var type = typeof(Program); <br />
    var attrs = type.GetCustomAttributes(typeof(TestImplementsAttribute), false); <br />
    Console.WriteLine(string.Format("TestImplementsAttribute:({0})",attrs.Length)); <br />
    foreach (var item in attrs) <br />
    { <br />
        Console.WriteLine("  " + item.GetType().FullName); <br />
    } <br />
    attrs = type.GetCustomAttributes(typeof(SerializableAttribute), false); <br />
    Console.WriteLine(string.Format("SerializableAttribute:({0})", attrs.Length)); <br />
    foreach (var item in attrs) <br />
    { <br />
        Console.WriteLine("  " + item.GetType().FullName); <br />
    } </p>
<p>    attrs = type.GetCustomAttributes(typeof(Attribute), false); <br />
    Console.WriteLine(string.Format("(base type)Attribute:({0})", attrs.Length)); <br />
    foreach (var item in attrs) <br />
    { <br />
        Console.WriteLine("  " + item.GetType().FullName); <br />
    } </p>
<p>}</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>输出为： </p>
<p><a href="http://images.cnblogs.com/cnblogs_com/whitewolf/201203/201203280030225138.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL3doaXRld29sZi8yMDEyMDMvMjAxMjAzMjgwMDMwMjMxOTQxLmpwZw==.jpg"></a></p>
<p>这里我们可以很清晰的看见当传入Attribute类型时候返回包含了SerializableAttribute和TestImplementsAttribute两个。</p>
<p>2：GetCustomAttributes每次返回的对象都是经过发射出来的没有缓存：</p>
<p>测试代码可以看出来,不是同一个地址引用：</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>private static void TestAttributeActiver() <br />
      { <br />
          var type = typeof(Program); <br />
          var attr1 = type.GetCustomAttributes(typeof(TestImplementsAttribute), false)[0]; <br />
          var attr2 = type.GetCustomAttributes(typeof(TestImplementsAttribute), false)[0]; <br />
          Console.WriteLine(Object.ReferenceEquals(attr1, attr2));            <br />
      } </p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>输出值为false。 </p>
<p>我们在看看</p>
<p>.下面是 reflector的反编译结果（Attribute.GetCustomAttributes）：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg"></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>internal static unsafe object[] GetCustomAttributes(Module decoratedModule, int decoratedMetadataToken, int pcaCount, RuntimeType attributeFilterType, bool mustBeInheritable, IList derivedAttributes)<br />
{<br />
    if (decoratedModule.Assembly.ReflectionOnly)<br />
    {<br />
        throw new InvalidOperationException(Environment.GetResourceString("Arg_ReflectionOnlyCA"));<br />
    }<br />
    MetadataImport metadataImport = decoratedModule.MetadataImport;<br />
    CustomAttributeRecord[] customAttributeRecords = CustomAttributeData.GetCustomAttributeRecords(decoratedModule, decoratedMetadataToken);<br />
    Type elementType = (((attributeFilterType == null) || attributeFilterType.IsValueType) || attributeFilterType.ContainsGenericParameters) ? typeof(object) : attributeFilterType;<br />
    if ((attributeFilterType == null) &amp;&amp; (customAttributeRecords.Length == 0))<br />
    {<br />
        return (Array.CreateInstance(elementType, 0) as object[]);<br />
    }<br />
    object[] attributes = Array.CreateInstance(elementType, customAttributeRecords.Length) as object[];<br />
    int length = 0;<br />
    SecurityContextFrame frame = new SecurityContextFrame();<br />
    frame.Push(decoratedModule.Assembly.InternalAssembly);<br />
    Assembly lastAptcaOkAssembly = null;<br />
    for (int i = 0; i &lt; customAttributeRecords.Length; i++)<br />
    {<br />
        bool flag2;<br />
        bool flag3;<br />
        object obj2 = null;<br />
        CustomAttributeRecord caRecord = customAttributeRecords[i];<br />
        RuntimeMethodHandle ctor = new RuntimeMethodHandle();<br />
        RuntimeType attributeType = null;<br />
        int namedArgs = 0;<br />
        IntPtr signature = caRecord.blob.Signature;<br />
        IntPtr blobEnd = (IntPtr) (((void*) signature) + caRecord.blob.Length);<br />
        if (FilterCustomAttributeRecord(caRecord, metadataImport, ref lastAptcaOkAssembly, decoratedModule, decoratedMetadataToken, attributeFilterType, mustBeInheritable, attributes, derivedAttributes, out attributeType, out ctor, out flag2, out flag3))<br />
        {<br />
            if (!ctor.IsNullHandle())<br />
            {<br />
                ctor.CheckLinktimeDemands(decoratedModule, decoratedMetadataToken);<br />
            }<br />
            RuntimeConstructorInfo.CheckCanCreateInstance(attributeType, flag3);<br />
            if (flag2)<br />
            {<br />
                obj2 = CreateCaObject(decoratedModule, ctor, ref signature, blobEnd, out namedArgs);<br />
            }<br />
            else<br />
            {<br />
                obj2 = attributeType.TypeHandle.CreateCaInstance(ctor);<br />
                if (Marshal.ReadInt16(signature) != 1)<br />
                {<br />
                    throw new CustomAttributeFormatException();<br />
                }<br />
                signature = (IntPtr) (((void*) signature) + 2);<br />
                namedArgs = Marshal.ReadInt16(signature);<br />
                signature = (IntPtr) (((void*) signature) + 2);<br />
            }<br />
            for (int j = 0; j &lt; namedArgs; j++)<br />
            {<br />
                string str;<br />
                bool flag4;<br />
                Type type3;<br />
                object obj3;<br />
                IntPtr ptr1 = caRecord.blob.Signature;<br />
                GetPropertyOrFieldData(decoratedModule, ref signature, blobEnd, out str, out flag4, out type3, out obj3);<br />
                try<br />
                {<br />
                    if (flag4)<br />
                    {<br />
                        if ((type3 == null) &amp;&amp; (obj3 != null))<br />
                        {<br />
                            type3 = (obj3.GetType() == typeof(RuntimeType)) ? typeof(Type) : obj3.GetType();<br />
                        }<br />
                        RuntimePropertyInfo property = null;<br />
                        if (type3 == null)<br />
                        {<br />
                            property = attributeType.GetProperty(str) as RuntimePropertyInfo;<br />
                        }<br />
                        else<br />
                        {<br />
                            property = attributeType.GetProperty(str, type3, Type.EmptyTypes) as RuntimePropertyInfo;<br />
                        }<br />
                        RuntimeMethodInfo setMethod = property.GetSetMethod(true) as RuntimeMethodInfo;<br />
                        if (setMethod.IsPublic)<br />
                        {<br />
                            setMethod.MethodHandle.CheckLinktimeDemands(decoratedModule, decoratedMetadataToken);<br />
                            setMethod.Invoke(obj2, BindingFlags.Default, null, new object[] { obj3 }, null, true);<br />
                        }<br />
                    }<br />
                    else<br />
                    {<br />
                        (attributeType.GetField(str) as RtFieldInfo).InternalSetValue(obj2, obj3, BindingFlags.Default, Type.DefaultBinder, null, false);<br />
                    }<br />
                }<br />
                catch (Exception exception)<br />
                {<br />
                    throw new CustomAttributeFormatException(string.Format(CultureInfo.CurrentUICulture, Environment.GetResourceString(flag4 ? "RFLCT.InvalidPropFail" : "RFLCT.InvalidFieldFail"), new object[] { str }), exception);<br />
                }<br />
            }<br />
            if (!signature.Equals(blobEnd))<br />
            {<br />
                throw new CustomAttributeFormatException();<br />
            }<br />
            attributes[length++] = obj2;<br />
        }<br />
    }<br />
    frame.Pop();<br />
    if ((length == customAttributeRecords.Length) &amp;&amp; (pcaCount == 0))<br />
    {<br />
        return attributes;<br />
    }<br />
    if (length == 0)<br />
    {<br />
        Array.CreateInstance(elementType, 0);<br />
    }<br />
    object[] destinationArray = Array.CreateInstance(elementType, (int) (length + pcaCount)) as object[];<br />
    Array.Copy(attributes, 0, destinationArray, 0, length);<br />
    return destinationArray;<br />
}</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>在这里我们可以见数组的创建<a href="http://www.aisto.com/roeder/dotnet/Default.aspx?Target=code://mscorlib:2.0.0.0:b77a5c561934e089/System.Array/CreateInstance(System.Type,Int32):System.Array" rel="external nofollow noreferrer">CreateInstance</a>等等。</p>
<p>   同时可以参见老赵前辈以前的关于Attribute反射的<a href="http://www.cnblogs.com/JeffreyZhao/archive/2009/11/10/GetCustomAttribute-always-returns-new-instances.html" rel="external nofollow noreferrer">一次失败的尝试（上）：原来GetCustomAttributes方法每次都返回新的实例</a>和<a href="http://www.cnblogs.com/JeffreyZhao/archive/2009/11/11/cannot-use-generic-attribute.html" rel="external nofollow noreferrer">一次失败的尝试（下）：无法使用泛型的Attribute</a>。</p>
<p>   不知道为什么在Attribute参数的检查是在我们的编译时期，参数必须是常量表达式，却在这里需要每次反射。</p>
<p>   本篇随笔只是个人使用心得记录，请勿拍砖。</p>
<p>作者：<a href="http://www.cnblogs.com/whitewolf/" rel="external nofollow noreferrer">破  狼</a> <br />
出处：<a href="http://www.cnblogs.com/whitewolf/" rel="external nofollow noreferrer">http://www.cnblogs.com/whitewolf/</a> <br />
本文版权归作者，欢迎转载，但未经作者同意必须保留此段声明，且在文章页面明显位置给出原文连接，否则保留追究法律责任的权利。该文章也同时发布在我的独立博客中-<a href="http://greengerong.com/" rel="external nofollow noreferrer">个人独立博客</a>、<a href="http://www.cnblogs.com/whitewolf/" rel="external nofollow noreferrer">博客园--破狼</a>和<a href="http://whitewolfblog.blog.51cto.com/" rel="external nofollow noreferrer">51CTO--破狼</a>。http://www.cnblogs.com/whitewolf/archive/2012/03/28/2420521.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 08:08:16</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Attribute鲜为人知的两个特性记录的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MY48Y9b.html" rel="bookmark">浅析目标市场的两大特性：可定位性和可营销性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 互联网的快速发展为我们提供了各种各样的便利,但对于很多站长来说同时也是一种压力,因为大量日常消费品的竞争已经达到白热化,所以部分站长选择了相对容易进入的利基市场.不过找到一个利基市场后,还不能马上进入,必须考虑这个目标市场是否在网上?用户是否能集中定位?是否真的有用户存在?总体来说就是目标市场的两大特性:可定位性和可营销性. 首先,可定位性:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgRBK1b.html" rel="bookmark">ECMAScript 2016 获得批准，主要增加两新特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Ecma国际批准了第七版的ECMAScript语言规范(ECMAScript 2016).ECMAScript是标准化的JavaScript语言,1997年发布了第一版,1998年和1999年发布了第二和第三个版本,之后ECMAScript沉寂 了许多年,直到Ajax流行起来后标准工作才再次起步,2009年发布了第五个版本,2015年发布了第六个版本,第七个版本又被称为ECMAScript 2016,与第六个版本相比变化并不多,主要是增加了两个新特性:Array.prototype.includ			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgPLL1p.html" rel="bookmark">产品定价的两大特性和八个步骤</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				经理们最头疼的营销问题是什么?定价.一方面,经理们觉得定价有时不受自己控制,而是为市场所左右;另一方面,也很难给定价设目标并衡量定价工作的好坏.尽管如此,我们还是要做出尽可能&quot;正确&quot;的定价,因为这会为公司带来巨大的收益. 本文作者通过观察并参与各种情况下的定价过程,发现了成功定价的2个特性和改进定价过程的8个步骤.一般来说,如果按这些标准行事,经理们将能定出更合适的价格,为公司带来更大的收益,并且自己也能够获得对定价的控制权. &amp;http://www.aliyun.com/zi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvrWr5M.html" rel="bookmark">逻辑卷管理的两个错误记录</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在使用lvm时遇到几个问题记录一下,如你也刚好碰到,可以减少点排错时间. 1. 创建lv时报错,可能是以前这个vg的数据有问题,不过它这里有个提示. Cannot change VG vgdata01 while PVs are missing. Consider vgreduce --removemissing. 确实,在列出PV时,报了一个unknown device. pvs unknown device vgdata01 lvm2 a-m 5.82t 0 所以在这个vg上创建100%VG			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOWP98z.html" rel="bookmark">关于C&num; 中的Attribute 特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Attribute与Property 的翻译区别 Attribute 一般译作&quot;特性&quot;,Property 仍然译为&quot;属性&quot;. Attribute 是什么 Attribute 是一种可由用户自由定义的修饰符(Modifier),可以用来修饰各种需要被修饰的目标. 简单的说,Attribute就是一种&quot;附着物&quot; -- 就像牡蛎吸附在船底或礁石上一样. 这些附着物的作用是为它们的附着体追加上一些额外的信息(这些信息就保存在附着物的体内)-- 比如&qu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmj7xqz.html" rel="bookmark">一起谈&period;NET技术，关于C&num; 中的Attribute 特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Attribute与Property 的翻译区别 Attribute 一般译作&quot;特性&quot;,Property 仍然译为&quot;属性&quot;. Attribute 是什么 Attribute 是一种可由用户自由定义的修饰符(Modifier),可以用来修饰各种需要被修饰的目标. 简单的说,Attribute就是一种&quot;附着物&quot; -- 就像牡蛎吸附在船底或礁石上一样. 这些附着物的作用是为它们的附着体追加上一些额外的信息(这些信息就保存在附着物的体内)-- 比如&qu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdL7nAp.html" rel="bookmark">&OpenCurlyDoubleQuote;&period;NET研究&rdquo;关于C&num; 中的Attribute 特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Attribute与Proper上海企业网站制作ty 的翻译区别 Attribute 一般译作&quot;特性&quot;,Property 仍然译为&quot;属性&quot;. Attribute 是什么 Attribute 是一种可由用户自由定义的修饰符(Modifier),可以用来修饰各种需要被修饰的目标. 简单的说,Attribute就是一种&quot;附着物&quot; -- 就像牡蛎吸附在船底或礁石上一样. 这些附着物的作用是为它们的附着体追加上一些额外的信息(这些信息就保存在附着物的体内)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnYJWjM.html" rel="bookmark">&lbrack;C&num;&rsqb;Attribute特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介       特性提供功能强大的方法,用以将元数据或声明信息与代码(程序集.类型.方法.属性等)相关联. 特性与程序实体关联后,即可在运行时使用名为&quot;反射&quot;的技术查询特性. 特性具有以下属性: 特性可向程序中添加元数据. 元数据是有关在程序中定义的类型的信息. 所有的 .NET 程序集都包含指定的一组元数据,这些元数据描述在程序集中定义的类型和类型成员. 可以添加自定义特性,以指定所需的任何附加信息.  可以将一个或多个特性应用到整个程序集.模块或较小的程序元素(如类和属性). 特			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9JxXgp.html" rel="bookmark">Attribute（特性），怎么用才更好？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  前几年: 2008年的某一天,我坐火车去北京.硬卧上铺,一晚上就到北京了.爬到上铺之后发现,旁边上铺有一老兄抱着一个笔记本,一开始还以为是看电影呢,仔细一看才发现--老天呀,居然在写代码!   这老兄也太工作狂了,当时可是晚上九点多了呀.屏幕里的IDE和vs有一点像,但又不是.问过了之后才知道,原来是大名鼎鼎的java(具体叫啥记不清楚了,好像是j2ee,对java相当的不熟,就是那个意思了).遇到java高手了,不能错失良机,要问问心中的疑问.   于是我就问他&quot;听说java都在用Hibe			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPO8mM.html" rel="bookmark" class="title">ora-01991&colon;故障的解决方法</a>
					<div>
						ora-01991:???????'D:\oracle\ora92\database\PWDorcl.ora' 原因是口令文件失效了 解决方法:在 init里面把 remote_login_passw ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9Mx7ARb.html" rel="bookmark" class="title">PHP教程&period;应用实例18</a>
					<div>
						教程|应用实例 基于PHP的聊天室(三)现在我们有了需要通过$REMOTE_ADDR变量来交叉引用的文件,这样我们可以区分出想要发贴的用户是否已经被扁或没有被扁.很简单: &lt;?php for ( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOONvz.html" rel="bookmark" class="title">Marc数据格式和数据库格式的转化体会</a>
					<div>
						数据|数据库 首先感谢CSDN上的djkhym(hym),给我的巨大的帮助,借鉴了他的程序的思路. Marc(machine readable catalogue)数据,机读目录数据.Marc格式和数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMREmKb.html" rel="bookmark" class="title">&period;Net开放源码工程之二---正则表达式函数库</a>
					<div>
						函数|正则     我想大家已经知道正则表达式在编程中的应用,在作为字符串处理.数据合法性校验上都有其快速.独到的作用,但是由于正则表达式的复杂性,这也是很多程序员在应用时候学习最困难的地方,下面这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLDqGb.html" rel="bookmark" class="title">常用软件测试工具的分析与比较</a>
					<div>
						工具名称 来源 类型 费用 功能概要 WinRunner Mercury公司 功能性测试 收费昂贵 Winrunner 最 主要的功能是自动重复执行某一固定的测试过程,它以脚本的形式记录下手工测试的一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKaGOp.html" rel="bookmark" class="title">MEF程序设计指南四：使用MEF声明导出（Exports）与导入（Imports）</a>
					<div>
						在MEF中,使用[System.ComponentModel.Composition.ExportAttribute]支持多种级别的导出部件配置,包括类.字段.属性以及方法 级别的导出部件,通过查看E ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7GEmM.html" rel="bookmark" class="title">Java Web 服务&colon; 比较 Metro 与 Axis2 性能</a>
					<div>
						Metro Web 服务堆栈是基于 JAXB 2.x 数据绑定和 JAX-WS 2.x Web 服务标准的参考实现,但它使用额外的组件来提供由 JAX-WS 定义的基本支持以外的特性.WS-Secur ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze41dwp.html" rel="bookmark" class="title">思维导图MindManager怎么实现资源共享</a>
					<div>
						  步骤一:登陆到Mindjet. 1.在MindManager思维导图软件状态栏的左下角,点击离线,选择连接. 2.在弹出的对话框内输入注册后的邮箱和密码,如果还没注册,点击注册,注册完再登陆. 3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlB1ZNz.html" rel="bookmark" class="title">金山打字通2013官方免费下载安装教程</a>
					<div>
						金山打字通2013官方版作为金山软件的重磅软件之一,它是一款功能齐全.数据丰富.界面友好的.集打字练习和测试于一体的打字软件.为了更好的为新手用户服务,今天小编整理了一份安装教程供大家学习.(仅为新鸟 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywA2dz.html" rel="bookmark" class="title">开心手机恢复大师扫描微信记录卡在0&percnt;怎么办</a>
					<div>
						  第一步:以&quot;360安全卫士&quot;,打开360安全卫士中的[更多]按钮. 第二步:选择[LSP修复],修复两次.并且重启系统即可. 友情提示: 如果仍旧无法解决,建议您第一时间回复, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJOgop.html" rel="bookmark" class="title">鼠标指针怎样更换？</a>
					<div>
						  1.打开控制面板,查看方式改为大图标,选择鼠标 2.点击正常选择,点击下面的浏览 3.找到你要换的鼠标指针图案 ( 如果要换成不是系统默认的,要先下载好要更换的鼠标指针图案文件.) 4.点击应用, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaDNLz.html" rel="bookmark" class="title">笔记本电脑哪个品牌最好？</a>
					<div>
						  笔记本哪个品牌最好?这是不少打算买新笔记本的朋友,经常会问到的一个问题.虽然PC近年来不景气,不过品牌依然众多,包括国产.国外品牌都有,另外各大笔记本品牌市场占有率相比以前也有了很大的变下,下面小 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6kl4b.html" rel="bookmark" class="title">ios做数据缓存后，显示数据的逻辑是怎样的？</a>
					<div>
						问题描述 ios做数据缓存后,显示数据的逻辑是怎样的? ios做数据缓存后,显示数据的逻辑是怎样的?因为有上拉加载更多,和下拉刷新,求思路 解决方案 iOS数据缓存iOS开发数据缓存玩转iOS开发 - ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKqv4M.html" rel="bookmark" class="title">poj 1751 Highways  MST</a>
					<div>
						   水到家的一道题,居然WA了3次--没注意到距离是double--没有输出的话要输出一行空行  /* author:jxy lang:C/C++ university:China,Xidian U ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oPomb.html" rel="bookmark" class="title">内网安全&mdash;&mdash;利用NSA Smbtouch批量检测内网</a>
					<div>
						本文讲的是内网安全--利用NSA Smbtouch批量检测内网, 0x00 前言 最近,NSA渗透工具被曝光,其中包含多个Windows远程漏洞利用工具,影响很大 本文不会具体介绍这些远程漏洞工具的使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmB0Rz.html" rel="bookmark" class="title">新浪作出的种种尝试，成则翘楚，败则岌岌</a>
					<div>
						微博庞大的流量如同一座难以开垦的金矿,新浪微博商业化,走得艰难而保守. 从新浪获悉,新浪微博全新的广告形式即将推出,但外界尚不清楚它具体的模样.这是继今年4月,新浪微博公布广告平台之后,其在广告模式上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVJ36b.html" rel="bookmark" class="title">php跳转-我用jQuery实现跳转到list&period;php页面，但是又想将这一页的数据通过php传给数据库</a>
					<div>
						问题描述 我用jQuery实现跳转到list.php页面,但是又想将这一页的数据通过php传给数据库 那么问题来了,跳转的jQuery代码失效了,即使出现alert标签,点确认后还是会直接跳转到act ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn73vZz.html" rel="bookmark" class="title">Python还是很重要的，不能丢。学习IF和WHILE</a>
					<div>
						number = 23 guess = int(input('Enter an interger : ')) if guess == number: print('Congratulations, y ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NonLM.html" rel="bookmark" class="title">vs2005 c&plus;&plus; wmi 访问远程主机</a>
					<div>
						问题描述 vs2005 c++ wmi 访问远程主机 用的开发环境VS2005&amp;C++,知道对方的ip,具有管理员权限的账户和密码,利用wmi,实现远程连接,同时可以将本机上的文件复制到远程主 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kq0lM.html" rel="bookmark" class="title">安卓开发环境的搭建&lpar;本文由本人根据网上的资料整理的成功版本&rpar;</a>
					<div>
						本文的版权归文章写的人所有,本人负责整理,如有侵权,请联系我删除,谢谢! 最近公司要开始进行安卓系统的开发,所以我也要学习一下如何搭建安卓的开发环境了,这里我选择的路线是jdk+adt这种模式来搭建的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxoRRyb.html" rel="bookmark" class="title">马云布局健康快乐两年后，阿里体育CEO谈创业：小步快走，不抢&OpenCurlyDoubleQuote;疯 口&rdquo;</a>
					<div>
						两年前,马老师宣布,健康和快乐是阿里巴巴集团为未来布局的两大战略方向,而体育产业是这两大方向的&quot;黄金交叉点&quot;--2015年的仲夏,阿里巴巴宣布成立体育公司,这个消息引起了财经.体育 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PgNQp.html" rel="bookmark" class="title">开源大数据技术专场（下午）&colon;Databricks、Intel、阿里、梨视频的技术实践</a>
					<div>
						开源大数据技术专场下午场在阿里技术专家封神的主持下开始,参与分享的嘉宾有Spark Commiter.来自Databriks的范文臣,HDFS committer.Intel 研发经理郑锴,逸晗网络科 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqQwqb.html" rel="bookmark" class="title">求wap网页游戏的源程序</a>
					<div>
						问题描述 谁有现成的.net的wap游戏程序,wap网页的游戏,比如:石头.骰子.吹牛==最好是C#+mysql的,看程序功能计价格,有意者请加我Q扣:39765425 解决方案 解决方案二:顶上去解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RZ13b.html" rel="bookmark" class="title">集群-c&plus;&plus;高手来，问点实在的问题</a>
					<div>
						问题描述 c++高手来,问点实在的问题 大家在项目中一般拿qt做客户端 吗?那服务端大家一般用什么写?linux c++ 吗?你们量大不大,有没有用c++写服务端做集群什么的?一般并发单台 能支持多少 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rDaop.html" rel="bookmark" class="title">c语言-C语言中，如何用&ast;画出一些图案！感觉没有思路！表达式和图案的联系</a>
					<div>
						问题描述 C语言中,如何用*画出一些图案!感觉没有思路!表达式和图案的联系 C语言中,如何用*画出一些图案!感觉没有思路!表达式和图案的联系 解决方案 你可以试试看现在纸上设计下草图,照着位置放不就可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWl5vGp.html" rel="bookmark" class="title">VS2005&sol;AJAX-VS2005中AJAX简单应用</a>
					<div>
						VS2005/AJAX-VS2005中AJAX简单应用 AJAX不用说大家都明白,不明白的请百度或Google一下人家比我说的专业,笔者写此篇文章不在于介绍多深奥的东西,这样只举一个很简单的例子来引导 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXn74z.html" rel="bookmark" class="title">大疆牵手阿里云，社区分享的终极之战</a>
					<div>
						本文讲的是大疆牵手阿里云,社区分享的终极之战[IT168专稿]形容一项创新技术或者一款产品的科技含量高,往往用黑科技一词,毫无疑问,无人机已成为典型的黑科技代表之一.自大疆无人机在国际市场上打开局面后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXvllb.html" rel="bookmark" class="title">html-bootstrap如何实现高度随屏幕大小动态变化</a>
					<div>
						问题描述 bootstrap如何实现高度随屏幕大小动态变化 使用bootstrap把页面中的一个div设置成了自适应的( &lt;div class=&quot;col-** col-**...&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLj7qM.html" rel="bookmark" class="title">struts2中文件上传拦截器 是不是不能在多个action中引用？？？</a>
					<div>
						问题描述 &lt;global-results&gt; &lt;result name=&quot;input&quot;&gt;/message.jsp&lt;/result&gt;&lt;/glo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ20GBz.html" rel="bookmark" class="title">Android编程实现大图滚动显示的方法&lowbar;Android</a>
					<div>
						本文实例讲述了Android编程实现大图滚动显示的方法.分享给大家供大家参考,具体如下: 问题: 我有一张比较大的图片,比如长宽都是屏幕的两倍大小,我想实现的功能是首先将图片居中显示,由于图片太大显然 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
